## greenbone-security-assistant 6.0.11+dfsg.1

=== CMakeLists.txt ===
# Greenbone Security Assistant
# $Id$
# Description: Top-level cmake control for greenbone-security-assistant
#
# Authors:
# Matthew Mundell <matthew.mundell@greenbone.net>
# Michael Wiegand <michael.wiegand@greenbone.net>
#
# Copyright:
# Copyright (C) 2009-2015 Greenbone Networks GmbH
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.

message ("-- Configuring greenbone-security-assistant...")

project (greenbone-security-assistant C)

cmake_minimum_required (VERSION 2.6)

if (POLICY CMP0005)
  cmake_policy (SET CMP0005 OLD)
endif (POLICY CMP0005)

# Needed for 'pkg_check_modules' function
include (FindPkgConfig)

if (NOT PKG_CONFIG_FOUND)
  message(FATAL_ERROR "pkg-config executable not found. Aborting.")
endif (NOT PKG_CONFIG_FOUND)

if (NOT CMAKE_BUILD_TYPE)
  set (CMAKE_BUILD_TYPE Debug)
endif (NOT CMAKE_BUILD_TYPE)

## Check existence required tools

set (MANDATORY_TOOL_MISSING FALSE)

if (NOT USE_LIBXSLT EQUAL 0)
  set (USE_LIBXSLT 1)
endif (NOT USE_LIBXSLT EQUAL 0)

find_program (PATH_TO_XSLTPROC xsltproc DOC "xsltproc command line "
              "xslt processor.")
if (NOT USE_LIBXSLT AND NOT PATH_TO_XSLTPROC)
  set (MANDATORY_TOOL_MISSING TRUE)
endif (NOT USE_LIBXSLT AND NOT PATH_TO_XSLTPROC)

if (MANDATORY_TOOL_MISSING)
  if (NOT USE_LIBXSLT AND NOT PATH_TO_XSLTPROC)
    message ("The xsltproc tool or libxslt is required.")
  endif (NOT USE_LIBXSLT AND NOT PATH_TO_XSLTPROC)
  message (FATAL_ERROR "One or more tools or libraries could not be found on "
                      "your system. Please check the logs above.")
endif (MANDATORY_TOOL_MISSING)

# TODO: Check for (optional) rats, flawfinder, splint, doxygen.

## Check for existance of required libraries
pkg_check_modules (LIBMICROHTTPD REQUIRED libmicrohttpd>=0.9.0)
pkg_check_modules (LIBXML REQUIRED libxml-2.0)
pkg_check_modules (GLIB REQUIRED glib-2.0>=2.16)
pkg_check_modules (LIBEXSLT REQUIRED libexslt)
pkg_check_modules (LIBOPENVAS_OMP REQUIRED libopenvas_omp>=8.0.0)
pkg_check_modules (LIBOPENVAS_BASE REQUIRED libopenvas_base>=8.0.0)
pkg_check_modules (LIBOPENVAS_MISC REQUIRED libopenvas_misc>=8.0.0)
pkg_check_modules (LIBXSLT REQUIRED libxslt)
pkg_check_modules (GNUTLS REQUIRED gnutls>=2.8)

# Linking against libgthread is only required for GLib versions using the old,
# deprecated thread API, i.e. version 2.30 and earlier.
if (${GLIB_VERSION} VERSION_LESS "2.31.0")
  set (GTHREAD_REQUIRED TRUE)
endif (${GLIB_VERSION} VERSION_LESS "2.31.0")

if (GTHREAD_REQUIRED)
  pkg_check_modules (GTHREAD REQUIRED gthread-2.0)
endif (GTHREAD_REQUIRED)

message (STATUS "Looking for libgcrypt...")
find_library (LIBGCRYPT gcrypt)
if (NOT LIBGCRYPT)
  message (SEND_ERROR "The libgcrypt library is required.")
else (NOT LIBGCRYPT)
  message (STATUS "Looking for libgcrypt... ${LIBGCRYPT}")
  execute_process (COMMAND libgcrypt-config --libs
    OUTPUT_VARIABLE LIBGCRYPT_LDFLAGS
    OUTPUT_STRIP_TRAILING_WHITESPACE)
  execute_process (COMMAND libgcrypt-config --cflags
    OUTPUT_VARIABLE LIBGCRYPT_CFLAGS
    OUTPUT_STRIP_TRAILING_WHITESPACE)
endif (NOT LIBGCRYPT)

if (NOT LIBMICROHTTPD_FOUND OR NOT LIBXML_FOUND OR NOT GLIB_FOUND OR
    (GTHREAD_REQUIRED AND NOT GTHREAD_FOUND) OR NOT LIBEXSLT_FOUND OR NOT
    LIBOPENVAS_OMP_FOUND OR NOT LIBOPENVAS_BASE_FOUND OR NOT
    LIBOPENVAS_MISC_FOUND OR NOT LIBXSLT_FOUND OR NOT GNUTLS_FOUND OR NOT
    LIBGCRYPT)
  message (FATAL_ERROR "One or more required libraries was not found "
    "(see message above), please install the missing "
    "libraries and run cmake again.")
endif (NOT LIBMICROHTTPD_FOUND OR NOT LIBXML_FOUND OR NOT GLIB_FOUND OR
  (GTHREAD_REQUIRED AND NOT GTHREAD_FOUND) OR NOT LIBEXSLT_FOUND OR NOT
  LIBOPENVAS_OMP_FOUND OR NOT LIBOPENVAS_BASE_FOUND OR NOT LIBOPENVAS_MISC_FOUND
  OR NOT LIBXSLT_FOUND OR NOT GNUTLS_FOUND OR NOT LIBGCRYPT)

## Retrieve svn revision (at configure time)
#  Not using Subversion_WC_INFO, as it would have to connect to the repo
find_program (SVN_EXECUTABLE svn DOC "subversion command line client")

macro (Subversion_GET_REVISION dir variable)
  execute_process (COMMAND ${SVN_EXECUTABLE} info ${CMAKE_SOURCE_DIR}/${dir}
    OUTPUT_VARIABLE ${variable}
    OUTPUT_STRIP_TRAILING_WHITESPACE)
  string (REGEX REPLACE "^(.*\n)?Revision: ([^\n]+).*"
    "\\2" ${variable} "${${variable}}")
endmacro (Subversion_GET_REVISION)

if (NOT CMAKE_BUILD_TYPE MATCHES "Release")
  if (EXISTS "${CMAKE_SOURCE_DIR}/.svn/")
    if (SVN_EXECUTABLE)
      Subversion_GET_REVISION(. ProjectRevision)
      set (SVN_REVISION ".SVN.r${ProjectRevision}")
    else (SVN_EXECUTABLE)
      set (SVN_REVISION ".SVN")
    endif (SVN_EXECUTABLE)
  endif (EXISTS "${CMAKE_SOURCE_DIR}/.svn/")
endif (NOT CMAKE_BUILD_TYPE MATCHES "Release")

## CPack configuration

set (CPACK_CMAKE_GENERATOR "Unix Makefiles")
set (CPACK_GENERATOR "TGZ")
set (CPACK_INSTALL_CMAKE_PROJECTS ".;greenbone-security-assistant;ALL;/")
set (CPACK_MODULE_PATH "")
set (CPACK_RESOURCE_FILE_LICENSE "${CMAKE_SOURCE_DIR}/COPYING")
set (CPACK_RESOURCE_FILE_README "${CMAKE_SOURCE_DIR}/README")
set (CPACK_RESOURCE_FILE_WELCOME "${CMAKE_SOURCE_DIR}/README")
set (CPACK_SOURCE_GENERATOR "TGZ")
set (CPACK_SOURCE_TOPLEVEL_TAG "")
set (CPACK_SYSTEM_NAME "")
set (CPACK_TOPLEVEL_TAG "")
set (CPACK_PACKAGE_VERSION_MAJOR "6")
set (CPACK_PACKAGE_VERSION_MINOR "0")

# Use this scheme for stable releases:
set (CPACK_PACKAGE_VERSION_PATCH "11${SVN_REVISION}")
set (CPACK_PACKAGE_VERSION "${CPACK_PACKAGE_VERSION_MAJOR}.${CPACK_PACKAGE_VERSION_MINOR}.${CPACK_PACKAGE_VERSION_PATCH}")
# Use this scheme for +betaN and +rcN releases:
#set (CPACK_PACKAGE_VERSION_PATCH "+beta1${SVN_REVISION}")
#set (CPACK_PACKAGE_VERSION "${CPACK_PACKAGE_VERSION_MAJOR}.${CPACK_PACKAGE_VERSION_MINOR}${CPACK_PACKAGE_VERSION_PATCH}")

set (CPACK_PACKAGE_FILE_NAME "${PROJECT_NAME}-${CPACK_PACKAGE_VERSION}")
set (CPACK_SOURCE_PACKAGE_FILE_NAME "${PROJECT_NAME}-${CPACK_PACKAGE_VERSION}")
set (CPACK_PACKAGE_VENDOR "The OpenVAS Project")
set (CPACK_SOURCE_IGNORE_FILES
"/.svn/"
"/_CPack_Packages/"
"/CMakeFiles/"
"cmake$"
"swp$"
"Cache.txt$"
".tar.gz"
"src/libgsad_omp.a$"
"src/libgsad_oap.a$"
"src/libgsad_base.a$"
"src/gsad$"
"install_manifest.txt"
"Makefile"
"src/html/build/"
"/doc/generated/"
"log.conf$"
"Doxyfile$"
"Doxyfile_full$"
"VERSION$"
"cpe-icons.xml$"
"zones.xml$"
)

include (CPack)

## Variables

if (NOT SYSCONFDIR)
  set (SYSCONFDIR "${CMAKE_INSTALL_PREFIX}/etc")
endif (NOT SYSCONFDIR)

if (NOT EXEC_PREFIX)
  set (EXEC_PREFIX "${CMAKE_INSTALL_PREFIX}")
endif (NOT EXEC_PREFIX)

if (NOT BINDIR)
  set (BINDIR "${EXEC_PREFIX}/bin")
endif (NOT BINDIR)

if (NOT SBINDIR)
  set (SBINDIR "${EXEC_PREFIX}/sbin")
endif (NOT SBINDIR)

if (NOT LIBDIR)
  set (LIBDIR "${EXEC_PREFIX}/lib")
endif (NOT LIBDIR)

if (NOT LOCALSTATEDIR)
  set (LOCALSTATEDIR "${CMAKE_INSTALL_PREFIX}/var")
endif (NOT LOCALSTATEDIR)

if (NOT INCLUDEDIR)
  set (INCLUDEDIR "${CMAKE_INSTALL_PREFIX}/include")
endif (NOT INCLUDEDIR)

if (NOT DATADIR)
  set (DATADIR "${CMAKE_INSTALL_PREFIX}/share")
endif (NOT DATADIR)

set (OPENVAS_STATE_DIR "${LOCALSTATEDIR}/lib/openvas")
set (OPENVAS_LOG_DIR   "${LOCALSTATEDIR}/log/openvas")
set (GSAD_PID_DIR   "${LOCALSTATEDIR}/run")
set (GSA_DATA_DIR "${DATADIR}/openvas/gsa")
set (GSA_LOCALE_DIR "${DATADIR}/locale")

# TODO: Eventually use own certificates
set (OPENVAS_SERVER_CERTIFICATE "${OPENVAS_STATE_DIR}/CA/servercert.pem")
set (OPENVAS_SERVER_KEY         "${OPENVAS_STATE_DIR}/private/CA/serverkey.pem")
set (OPENVAS_CA_CERTIFICATE     "${OPENVAS_STATE_DIR}/CA/cacert.pem")

# TODO: Eventually have all configurations collected here:
set (GSA_CONFIG_DIR         "${SYSCONFDIR}/openvas/")
set (GSA_CONFIG_FILE        "${SYSCONFDIR}/openvas/gsa.conf")

message ("-- Install prefix: ${CMAKE_INSTALL_PREFIX}")

## Files generated on installation

add_custom_target (cpe-icon-dict
                   ALL
                   COMMENT "Generating CPE icon dictionary"
                   COMMAND sh "${CMAKE_SOURCE_DIR}/tools/generate-cpe-icon-dict.sh" --src_path "${CMAKE_SOURCE_DIR}/src/html/classic/img/cpe" > ${CMAKE_CURRENT_BINARY_DIR}/cpe-icons.xml
                   WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}/tools)

add_custom_target (zone-dict
                   ALL
                   COMMENT "Generating timezone dictionary"
                   COMMAND sh "${CMAKE_SOURCE_DIR}/tools/generate-zone-dict.sh" > ${CMAKE_CURRENT_BINARY_DIR}/zones.xml
                   WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}/tools)

## Version

string (REPLACE "
" "" GSAD_VERSION ${CPACK_PACKAGE_VERSION})

# Configure Doxyfile with version number
configure_file (doc/Doxyfile.in doc/Doxyfile)
configure_file (doc/Doxyfile_full.in doc/Doxyfile_full)
configure_file (VERSION.in VERSION)
configure_file (src/gsad_log_conf.cmake_in src/gsad_log.conf)

## Install

install (FILES src/html/classic/favicon.gif
               src/html/classic/gsad.xsl
               src/html/classic/gsa-style.css
               src/html/classic/gsa-login.css
               src/html/classic/graphics.xsl
               src/html/classic/help.xsl
               src/html/classic/omp.xsl
               src/html/classic/omp-doc.xsl
               src/html/classic/rnc.xsl
               src/html/classic/os.xml
               src/html/classic/wizard.xsl
         DESTINATION ${GSA_DATA_DIR}/classic)

install (FILES src/html/classic/js/d3.tip.js
               src/html/classic/js/d3.v3.min.js
               src/html/classic/js/gsa_bar_chart.js
               src/html/classic/js/gsa_bubble_chart.js
               src/html/classic/js/gsa_donut_chart.js
               src/html/classic/js/gsa_graphics_base.js
               src/html/classic/js/gsa_line_chart.js
         DESTINATION ${GSA_DATA_DIR}/classic/js)

install (FILES src/html/classic/login/login.html
               src/html/classic/gsa-login.css
               src/html/classic/favicon.gif
         DESTINATION ${GSA_DATA_DIR}/classic/login)

install (FILES src/html/classic/img/gsa_splash.png
         DESTINATION ${GSA_DATA_DIR}/classic/login/img)

install (FILES src/html/classic/help_de.xsl
               src/html/classic/help_ru.xsl
               src/html/classic/help_zh_CN.xsl
         DESTINATION ${GSA_DATA_DIR}/classic)

install (FILES src/html/classic/img/style/window_dec_a.png
               src/html/classic/img/style/window_dec_b.png
               src/html/classic/img/style/window_dec_c.png
         DESTINATION ${GSA_DATA_DIR}/classic/login/img/style)

install (FILES src/html/classic/img/agent.png
               src/html/classic/img/descending.png
               src/html/classic/img/key.png
               src/html/classic/img/p_bar_bg.png
               src/html/classic/img/start_inactive.png
               src/html/classic/img/alert_sign.png
               src/html/classic/img/details.png
               src/html/classic/img/details_inactive.png
               src/html/classic/img/list_inactive.png
               src/html/classic/img/p_bar_done.png
               src/html/classic/img/start.png
               src/html/classic/img/ascending_inactive.png
               src/html/classic/img/download.png
               src/html/classic/img/list.png
               src/html/classic/img/p_bar_error.png
               src/html/classic/img/stop_inactive.png
               src/html/classic/img/ascending.png

=== src/CMakeLists.txt ===
# Greenbone Security Assistant
# $Id$
# Description: CMakefile for GSAD sources.
#
# Authors:
# Matthew Mundell <matthew.mundell@greenbone.net>
# Michael Wiegand <michael.wiegand@greenbone.net>
#
# Copyright:
# Copyright (C) 2009, 2014 Greenbone Networks GmbH
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.

## Config

include_directories (${LIBMICROHTTPD_INCLUDE_DIRS} ${LIBXML_INCLUDE_DIRS}
                     ${GLIB_INCLUDE_DIRS} ${LIBEXSLT_INCLUDE_DIRS}
                     ${LIBOPENVAS_OMP_INCLUDE_DIRS}
                     ${LIBOPENVAS_BASE_INCLUDE_DIRS}
                     ${LIBOPENVAS_MISC_INCLUDE_DIRS} ${LIBXSLT_INCLUDE_DIRS}
                     ${GNUTLS_INCLUDE_DIRS})

find_package (Threads)

## Libraries

add_library (gsad_base STATIC gsad_base.c)
target_link_libraries (gsad_base ${LIBMICROHTTPD_LDFLAGS} ${LIBXML_LDFLAGS}
                       ${GLIB_LDFLAGS} ${GTHREAD_LDFLAGS} ${LIBEXSLT_LDFLAGS}
                       ${LIBXSLT_LDFLAGS} ${LIBOPENVAS_OMP_LDFLAGS}
                       ${LIBOPENVAS_BASE_LDFLAGS} ${LIBOPENVAS_MISC_LDFLAGS}
                       ${GNUTLS_LDFLAGS})

add_library (gsad_omp STATIC gsad_omp.c)
target_link_libraries (gsad_omp ${LIBMICROHTTPD_LDFLAGS} ${LIBXML_LDFLAGS}
                       ${GLIB_LDFLAGS} ${GTHREAD_LDFLAGS} ${LIBEXSLT_LDFLAGS}
                       ${LIBXSLT_LDFLAGS} ${LIBOPENVAS_OMP_LDFLAGS}
                       ${LIBOPENVAS_BASE_LDFLAGS} ${LIBOPENVAS_MISC_LDFLAGS}
                       ${GNUTLS_LDFLAGS})

add_library (gsad_xslt_ext STATIC xslt_i18n.c)
target_link_libraries (gsad_omp ${LIBMICROHTTPD_LDFLAGS} ${LIBXML_LDFLAGS}
                       ${GLIB_LDFLAGS} ${GTHREAD_LDFLAGS} ${LIBEXSLT_LDFLAGS}
                       ${LIBXSLT_LDFLAGS} ${LIBOPENVAS_OMP_LDFLAGS}
                       ${LIBOPENVAS_BASE_LDFLAGS} ${LIBOPENVAS_MISC_LDFLAGS}
                       ${GNUTLS_LDFLAGS})

## Program

add_executable (gsad gsad.c validator.c)
target_link_libraries (gsad gsad_omp gsad_base gsad_xslt_ext ${LIBGCRYPT_LDFLAGS} ${CMAKE_THREAD_LIBS_INIT})
set_target_properties (gsad PROPERTIES LINKER_LANGUAGE C)

if (USE_LIBXSLT)
  message (STATUS "Internal XSL transformations, with libxslt.")
  add_definitions (-DUSE_LIBXSLT)
else (USE_LIBXSLT)
  message (STATUS "External XSL transformations, with xsltproc.")
endif (USE_LIBXSLT)

if (GSAD_VERSION)
  add_definitions (-DGSAD_VERSION=\\\"${GSAD_VERSION}\\\")
endif (GSAD_VERSION)

if (OPENVAS_USERS_DIR)
  add_definitions (-DOPENVAS_USERS_DIR=\\\"${OPENVAS_USERS_DIR}\\\")
endif (OPENVAS_USERS_DIR)

if (OPENVAS_CONFIG_FILE)
  add_definitions (-DOPENVAS_CONFIG_FILE=\\\"${OPENVAS_CONFIG_FILE}\\\")
endif (OPENVAS_CONFIG_FILE)

if (OPENVAS_SERVER_CERTIFICATE)
  add_definitions (-DOPENVAS_SERVER_CERTIFICATE=\\\"${OPENVAS_SERVER_CERTIFICATE}\\\")
endif (OPENVAS_SERVER_CERTIFICATE)

if (OPENVAS_SERVER_KEY)
  add_definitions (-DOPENVAS_SERVER_KEY=\\\"${OPENVAS_SERVER_KEY}\\\")
endif (OPENVAS_SERVER_KEY)

if (OPENVAS_CA_CERTIFICATE)
  add_definitions (-DOPENVAS_CA_CERTIFICATE=\\\"${OPENVAS_CA_CERTIFICATE}\\\")
endif (OPENVAS_CA_CERTIFICATE)

if (GSA_DATA_DIR)
  add_definitions (-DGSA_DATA_DIR=\\\"${GSA_DATA_DIR}\\\")
endif (GSA_DATA_DIR)

if (GSAD_PID_DIR)
  add_definitions (-DGSAD_PID_DIR=\\\"${GSAD_PID_DIR}\\\")
endif (GSAD_PID_DIR)

if (GSA_CONFIG_DIR)
  add_definitions (-DGSA_CONFIG_DIR=\\\"${GSA_CONFIG_DIR}\\\")
endif (GSA_CONFIG_DIR)

if (GSA_LOCALE_DIR)
  add_definitions (-DGSA_LOCALE_DIR=\\\"${GSA_LOCALE_DIR}\\\")
endif (GSA_LOCALE_DIR)

add_definitions (-DOPENVAS_OS_NAME=\\\"${CMAKE_SYSTEM}\\\")
add_definitions (-DPREFIX=\\\"${CMAKE_INSTALL_PREFIX}\\\")

## Install

install (TARGETS gsad
         RUNTIME DESTINATION ${SBINDIR}
         LIBRARY DESTINATION ${LIBDIR}
         ARCHIVE DESTINATION ${LIBDIR}/static)

## Static analysis

add_custom_target (splint COMMENT "Running splint..."
                   COMMAND sh -c \"splint -booltype gboolean -predboolint +unixlib +export-header `pkg-config --cflags glib-2.0` `pkg-config --cflags libopenvas` ${CMAKE_CURRENT_SOURCE_DIR}/*.c\")

add_custom_target (rats COMMENT "Running rats..."
                   COMMAND sh -c \"rats --warning 2 ${CMAKE_CURRENT_SOURCE_DIR}/*.[ch]\")

add_custom_target (flawfinder COMMENT "Running flawfinder..."
                   COMMAND sh -c \"flawfinder ${CMAKE_CURRENT_SOURCE_DIR}/*.[ch]\")

add_custom_target (check COMMENT "Checking code...")
add_dependencies (check splint rats flawfinder)

## Very superficial check if stylesheets are fine

if (PATH_TO_XSLTPROC)
  add_custom_target (omp-xsl-syntax ALL
                                    COMMENT "Checking syntax of omp.xsl"
                                    COMMAND xsltproc ${CMAKE_CURRENT_SOURCE_DIR}/html/classic/omp.xsl
                                    DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/html/classic/omp.xsl)
  add_custom_target (gsad-xsl-syntax ALL
                                     COMMENT "Checking syntax of gsad.xsl"
                                     COMMAND xsltproc ${CMAKE_CURRENT_SOURCE_DIR}/html/classic/gsad.xsl
                                     DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/html/classic/gsad.xsl)
  add_custom_target (help-xsl-syntax ALL
                                     COMMENT "Checking syntax of help.xsl"
                                     COMMAND xsltproc ${CMAKE_CURRENT_SOURCE_DIR}/html/classic/help.xsl
                                     DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/html/classic/help.xsl)
  add_custom_target (help_de-xsl-syntax ALL
                                     COMMENT "Checking syntax of help_de.xsl"
                                     COMMAND xsltproc ${CMAKE_CURRENT_SOURCE_DIR}/html/classic/help_de.xsl
                                     DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/html/classic/help_de.xsl)
  add_custom_target (help_ru-xsl-syntax ALL
                                     COMMENT "Checking syntax of help_ru.xsl"
                                     COMMAND xsltproc ${CMAKE_CURRENT_SOURCE_DIR}/html/classic/help_ru.xsl
                                     DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/html/classic/help_ru.xsl)
  add_custom_target (help_zh_CN-xsl-syntax ALL
                                     COMMENT "Checking syntax of help_zh_CN.xsl"
                                     COMMAND xsltproc ${CMAKE_CURRENT_SOURCE_DIR}/html/classic/help_zh_CN.xsl
                                     DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/html/classic/help_zh_CN.xsl)
  add_custom_target (rnc-xsl-syntax ALL
                                    COMMENT "Checking syntax of rnc.xsl"
                                    COMMAND xsltproc ${CMAKE_CURRENT_SOURCE_DIR}/html/classic/rnc.xsl
                                    DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/html/classic/rnc.xsl)
  add_custom_target (omp-doc-xsl-syntax ALL
                                        COMMENT "Checking syntax of omp-doc.xsl"
                                        COMMAND xsltproc ${CMAKE_CURRENT_SOURCE_DIR}/html/classic/omp-doc.xsl
                                        DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/html/classic/omp-doc.xsl)
else (PATH_TO_XSLTPROC)
  message ("Not performing simple stylesheet tests -- xsltproc not found.")
endif (PATH_TO_XSLTPROC)

## Tag files

set (C_FILES "${CMAKE_CURRENT_SOURCE_DIR}/*.c")
add_custom_target (etags COMMENT "Building TAGS..."
                   COMMAND etags ${C_FILES})
add_custom_target (ctags COMMENT "Building tags..."
                   COMMAND ctags ${C_FILES})
add_custom_target (tags COMMENT "Building tags files...")
add_dependencies (tags etags ctags)

## gettext translations
add_subdirectory (po)

## End

=== src/po/CMakeLists.txt ===
# Greenbone Security Assistant
# $Id$
# Description: CMakefile for GSAD sources.
#
# Authors:
# Timo Pollmeier <timo.pollmeier@greenbone.net>
#
# Copyright:
# Copyright (C) 2015 Greenbone Networks GmbH
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.

include (FindGettext)
include (FindPythonInterp)

macro (MAKE_TRANSLATION _LANG)
  file (MAKE_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/${_LANG})
  add_custom_command (OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/${_LANG}/gsad_xsl.mo
                      DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/gsad_xsl-${_LANG}.po
                      COMMAND ${GETTEXT_MSGFMT_EXECUTABLE}
                      ARGS ${CMAKE_CURRENT_SOURCE_DIR}/gsad_xsl-${_LANG}.po -o ${CMAKE_CURRENT_BINARY_DIR}/${_LANG}/gsad_xsl.mo)
  install (FILES ${CMAKE_CURRENT_BINARY_DIR}/${_LANG}/gsad_xsl.mo
           DESTINATION ${GSA_LOCALE_DIR}/${_LANG}/LC_MESSAGES)

  add_custom_command (OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/gsad_xsl-${_LANG}-merged.po
                      DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/gsad_xsl.pot
                      COMMAND ${GETTEXT_MSGMERGE_EXECUTABLE}
                      ARGS ${CMAKE_CURRENT_SOURCE_DIR}/gsad_xsl-${_LANG}.po
                      ${CMAKE_CURRENT_BINARY_DIR}/gsad_xsl.pot
                      -o ${CMAKE_CURRENT_BINARY_DIR}/gsad_xsl-${_LANG}-merged.po)
endmacro ()

if (GETTEXT_FOUND)

  MAKE_TRANSLATION (de)
  MAKE_TRANSLATION (ru)
  MAKE_TRANSLATION (zh_CN)

  add_custom_target (gettext-mo-files
                     ALL
                     DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/de/gsad_xsl.mo
                     DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/ru/gsad_xsl.mo
                     DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/zh_CN/gsad_xsl.mo
                     COMMENT "Created translation .mo files")

  add_custom_target (gettext-po-files
                     DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/gsad_xsl.pot
                     DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/gsad_xsl-de-merged.po
                     DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/gsad_xsl-ru-merged.po
                     DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/gsad_xsl-zh_CN-merged.po
                     COMMENT "Created translation .po files")

  if (PYTHONINTERP_FOUND)
    add_custom_command (OUTPUT  ${CMAKE_CURRENT_BINARY_DIR}/gsad_xsl.pot
                        COMMAND ${PYTHON_EXECUTABLE} "${CMAKE_SOURCE_DIR}/tools/xsl2pot"
                        ARGS    "${CMAKE_SOURCE_DIR}/src/html/classic"
                                "${CMAKE_CURRENT_BINARY_DIR}/gsad_xsl.pot"
                        DEPENDS ${CMAKE_SOURCE_DIR}/src/html/classic/*.xsl
                        COMMENT "Creating translation template (.pot) files")
    add_custom_target (gettext-pot-files
                       DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/gsad_xsl.pot)
  else (PYTHONINTERP_FOUND)
    message (WARNING "Python interpreter not found, cannot run .pot generator.")
  endif (PYTHONINTERP_FOUND)

else (GETTEXT_FOUND)
  message (WARNING "Could not build translation files: gettext not found.")
endif (GETTEXT_FOUND)

=== src/html/its/CMakeLists.txt ===
# Greenbone Security Assistant
# $Id$
# Description: CMakefile for IT Schwachstellenampel sources.
#
# Authors:
# Timo Pollmeier <timo.pollmeier@greenbone.net>
#
# Copyright:
# Copyright (C) 2014 Greenbone Networks GmbH
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.

## Install

install (FILES favicon.gif gsad.xsl gsa-style.css
               help.xsl omp.xsl
         DESTINATION ${GSA_DATA_DIR}/its)

install (FILES login/login.html
               gsa-style.css
               favicon.gif
         DESTINATION ${GSA_DATA_DIR}/its/login)

install (FILES img/its_logo.png
         DESTINATION ${GSA_DATA_DIR}/its/login/img)

install (FILES img/acs_logo.png
               img/bsi_logo.png
               img/its_logo.png
               img/OpenVAS-logo.png
               img/greenbone-logo.png
               img/callout_blue.gif
               img/details.png
               img/info_big.png
               img/info.png
               img/printer.png
               img/datensicherheit_big.png
               img/datensicherheit.png
               img/settings.png
               img/shutdown.png
               img/tl_flash_flash_flash.gif
               img/tl_flash_off_off.gif
               img/tl_flash_on_off.gif
               img/tl_off_off_off.png
               img/tl_off_off_on.png
               img/tl_off_on_off.png
               img/tl_on_off_off.png
         DESTINATION ${GSA_DATA_DIR}/its/img)

## Static analysis

## Very superficial check if stylesheets are fine

if (PATH_TO_XSLTPROC)
  add_custom_target (its-omp-xsl-syntax ALL
                                        COMMENT "Checking syntax of omp.xsl (IT Schwachstellenampel)"
                                        COMMAND xsltproc ${CMAKE_CURRENT_SOURCE_DIR}/omp.xsl
                                        DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/omp.xsl)
  add_custom_target (its-gsad-xsl-syntax ALL
                                         COMMENT "Checking syntax of gsad.xsl (IT Schwachstellenampel)"
                                         COMMAND xsltproc ${CMAKE_CURRENT_SOURCE_DIR}/gsad.xsl
                                         DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/gsad.xsl)
  add_custom_target (its-help-xsl-syntax ALL
                                         COMMENT "Checking syntax of help.xsl (IT Schwachstellenampel)"
                                         COMMAND xsltproc ${CMAKE_CURRENT_SOURCE_DIR}/help.xsl
                                         DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/help.xsl)
else (PATH_TO_XSLTPROC)
  message ("Not performing simple stylesheet tests -- xsltproc not found.")
endif (PATH_TO_XSLTPROC)

## End

=== debian/changelog ===
greenbone-security-assistant (6.0.11+dfsg.1-1) unstable; urgency=medium

  * Import upstream version to Debian (Closes: #840082)

 -- SZ Lin (林上智) <szlin@cs.nctu.edu.tw>  Thu, 13 Oct 2016 13:14:46 +0800

greenbone-security-assistant (6.0.10-0kali1) kali-experimental; urgency=medium

  * Import new upstream release

 -- Sophie Brun <sophie@freexian.com>  Wed, 22 Jun 2016 12:02:31 +0200

greenbone-security-assistant (6.0.5-0kali1) kali-dev; urgency=medium

  * Import new upstream release

 -- Sophie Brun <sophie@freexian.com>  Fri, 11 Sep 2015 09:39:53 +0200

greenbone-security-assistant (6.0.1-0kali2) kali-dev; urgency=medium

  * Add a proper systemd service file.

 -- Raphaël Hertzog <hertzog@debian.org>  Tue, 28 Jul 2015 17:19:26 +0200

greenbone-security-assistant (6.0.1-0kali1) kali; urgency=medium

  * Import new upstream release

 -- Sophie Brun <sophie@freexian.com>  Mon, 13 Apr 2015 10:43:40 +0200

greenbone-security-assistant (5.0.1-0kali4) kali-dev; urgency=medium

  * Rebuild in kali-dev for the libgcrypt20/gnutls28 transitions.

 -- Raphaël Hertzog <hertzog@debian.org>  Fri, 21 Nov 2014 20:30:25 +0100

greenbone-security-assistant (5.0.1-0kali3) kali; urgency=medium

  * Disable start/stop of initscript in postinst.

 -- Raphaël Hertzog <hertzog@debian.org>  Tue, 30 Sep 2014 09:20:19 +0200

greenbone-security-assistant (5.0.1-0kali2) kali; urgency=medium

  * Fix init script by dropping options related to openvas-administrator.

 -- Raphaël Hertzog <hertzog@debian.org>  Mon, 04 Aug 2014 11:38:03 +0200

greenbone-security-assistant (5.0.1-0kali1) kali; urgency=medium

  * New upstream release. 
  * Add build depends libxml2-dev as mentionned in INSTALL
  * Add missing file source/format
  * Add missing file debian/copyright
  * Update debian/rules to use debhelper 9
  * Update build-depends: debhelper 9 and drop hardening-wrapper
  * Update debian/compat
  * Update version of build depends libopenvas-dev >=7
  * Create files .manpages and .docs
  * Add flawfinder as build depends
  * Add splint as build depends
  * Disable dh_auto_test as it fails
  * Add Default-stop 1 in file .init

 -- Sophie Brun <sophie@freexian.com>  Fri, 01 Aug 2014 14:18:09 +0200

greenbone-security-assistant (4.0.0-0kali2) kali; urgency=low

  * Added texlive-latex-extra as an install depend to allow for PDF
    reports (Closes: 0000430)

 -- Raphaël Hertzog <hertzog@debian.org>  Tue, 03 Dec 2013 09:41:48 -0700

greenbone-security-assistant (4.0.0-0kali1) kali; urgency=low

  * New upstream release.
  * Enable dh_install --list-missing.
  * Update build dependencies.

 -- Raphaël Hertzog <hertzog@debian.org>  Thu, 02 May 2013 12:21:49 +0200

greenbone-security-assistant (3.0.3-1kali0) kali; urgency=low

  * Version update

 -- Mati Aharoni <muts@kali.org>  Tue, 04 Dec 2012 12:16:41 -0500

greenbone-security-assistant (3.0+beta8-1kali1) kali; urgency=low

  * Version bump

 -- Mati Aharoni <muts@kali.org>  Tue, 04 Dec 2012 11:08:15 -0500

greenbone-security-assistant (3.0+beta8-1kali0) kali; urgency=low

  * Kali Import

 -- Mati Aharoni <muts@kali.org>  Fri, 23 Nov 2012 01:52:25 +0000

=== debian/control ===
Source: greenbone-security-assistant
Section: admin
Priority: optional
Maintainer: Debian Security Tools Packaging Team <pkg-security-team@lists.alioth.debian.org>
Uploaders: ChangZhuo Chen (陳昌倬) <czchen@debian.org>,
           SZ Lin (林上智) <szlin@cs.nctu.edu.tw>
Build-Depends: debhelper (>= 9.20151219),
               dh-systemd,
               cmake (>= 2.6),
               doxygen,
               libmicrohttpd-dev (>= 0.9.0),
               libopenvas-dev (>= 8.0.7),
               libxslt1-dev,
               pkg-config,
               xsltproc,
               xmltoman,
               libxml2-dev,
               flawfinder,
               splint
Standards-Version: 3.9.8
Homepage: http://www.openvas.org/
Vcs-Git: https://anonscm.debian.org/git/pkg-security/greenbone-security-assistant.git
Vcs-Browser: https://anonscm.debian.org/git/pkg-security/greenbone-security-assistant.git

Package: greenbone-security-assistant-common
Section: net
Architecture: all
Recommends: greenbone-security-assistant
Depends: ${misc:Depends}, texlive-latex-extra, libjs-d3
Multi-Arch: foreign
Description: architecture independent files for greenbone-security-assistant
 The Greenbone Security Assistant is a web application that
 connects to the OpenVAS Manager and OpenVAS Administrator
 to provide for a full-featured user interface for
 vulnerability management.
 .
 This package contains the common greenbone-security-assistant
 files shared by all architectures.

Package: greenbone-security-assistant
Section: net
Architecture: any
Depends: lsb-base (>= 3.0-6),
         greenbone-security-assistant-common (= ${source:Version}),
         ${shlibs:Depends},
         ${misc:Depends}
Description: remote network security auditor - web interface
 The Greenbone Security Assistant is a web application that
 connects to the OpenVAS Manager and OpenVAS Administrator
 to provide for a full-featured user interface for
 vulnerability management.

=== debian/watch ===
version=4
 opts=dversionmangle=s/\+(debian|dfsg|ds|deb)(\.\d+)?$// \
 http://wald.intevation.org/frs/?group_id=29 \
 .*/greenbone-security-assistant-(\d[\d.]*)\.tar\.gz$

## greenbone-security-assistant 7.0.2%2Bdfsg.1

=== src/html/its/CMakeLists.txt ===
--- 
+++ 
@@ -24,13 +24,17 @@
 
 ## Install
 
-install (FILES favicon.gif gsad.xsl gsa-style.css
-               help.xsl omp.xsl
+install (FILES css/gsa-style.css
+               css/gsa-base.css
+         DESTINATION ${GSA_DATA_DIR}/its/css)
+
+install (FILES favicon.gif
+               gsad.xsl
+               help.xsl
+               omp.xsl
          DESTINATION ${GSA_DATA_DIR}/its)
 
-install (FILES login/login.html
-               gsa-style.css
-               favicon.gif
+install (FILES favicon.gif
          DESTINATION ${GSA_DATA_DIR}/its/login)
 
 install (FILES img/its_logo.png

=== debian/changelog ===
greenbone-security-assistant (7.0.2+dfsg.1-2build1) artful; urgency=medium

  * No-change rebuild against latest libmicrohttpd

 -- Jeremy Bicha <jbicha@ubuntu.com>  Sun, 09 Jul 2017 13:50:43 -0400

greenbone-security-assistant (7.0.2+dfsg.1-2) unstable; urgency=medium

  * Move package from experimental to sid archive
  * Bump standards version to 4.0.0 

 -- SZ Lin (林上智) <szlin@debian.org>  Tue, 20 Jun 2017 11:29:45 +0800

greenbone-security-assistant (7.0.2+dfsg.1-1~exp1) experimental; urgency=medium

  *  Import new upstream release
  *  Move to experimental archive

 -- SZ Lin (林上智) <szlin@debian.org>  Thu, 23 Mar 2017 19:01:12 +0800

greenbone-security-assistant (7.0.0+dfsg.1-1) UNRELEASED; urgency=medium

  * Import new upstream release

 -- SZ Lin (林上智) <szlin@cs.nctu.edu.tw>  Mon, 14 Nov 2016 22:05:30 +0800

greenbone-security-assistant (6.0.11+dfsg.1-2) unstable; urgency=low

  * Fix upstream to make the build reproducible;
    thanks to Reiner Herrmann (Closes: #843110)

 -- SZ Lin (林上智) <szlin@cs.nctu.edu.tw>  Sat, 05 Nov 2016 16:06:54 +0800

=== debian/control ===
--- 
+++ 
@@ -3,13 +3,13 @@
 Priority: optional
 Maintainer: Debian Security Tools Packaging Team <pkg-security-team@lists.alioth.debian.org>
 Uploaders: ChangZhuo Chen (陳昌倬) <czchen@debian.org>,
-           SZ Lin (林上智) <szlin@cs.nctu.edu.tw>
-Build-Depends: debhelper (>= 9.20151219),
+           SZ Lin (林上智) <szlin@debian.org>
+Build-Depends: debhelper (>= 9.20160709~),
                dh-systemd,
-               cmake (>= 2.6),
+               cmake (>= 2.8),
                doxygen,
                libmicrohttpd-dev (>= 0.9.0),
-               libopenvas-dev (>= 8.0.7),
+               libopenvas-dev (>= 9),
                libxslt1-dev,
                pkg-config,
                xsltproc,
@@ -17,7 +17,7 @@
                libxml2-dev,
                flawfinder,
                splint
-Standards-Version: 3.9.8
+Standards-Version: 4.0.0
 Homepage: http://www.openvas.org/
 Vcs-Git: https://anonscm.debian.org/git/pkg-security/greenbone-security-assistant.git
 Vcs-Browser: https://anonscm.debian.org/git/pkg-security/greenbone-security-assistant.git
@@ -26,7 +26,7 @@
 Section: net
 Architecture: all
 Recommends: greenbone-security-assistant
-Depends: ${misc:Depends}, texlive-latex-extra, libjs-d3
+Depends: ${misc:Depends}, texlive-latex-extra
 Multi-Arch: foreign
 Description: architecture independent files for greenbone-security-assistant
  The Greenbone Security Assistant is a web application that

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/architecture.mk

# Teach splint to find header files in multiarch path (workaround #675025)
export CPATH = /usr/include/$(DEB_HOST_MULTIARCH):/usr/include
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@ --parallel --with systemd

override_dh_auto_configure:
	dh_auto_configure -- -DCMAKE_INSTALL_PREFIX=/usr -DSYSCONFDIR=/etc -DLOCALSTATEDIR=/var -DCMAKE_BUILD_TYPE=release

override_dh_install:
	dh_install --list-missing

override_dh_clean:
	dh_clean

override_dh_auto_test:
	# disabled because make check fails

override_dh_strip:
	dh_strip --dbgsym-migration='greenbone-security-assistant (<< 6.0.10-1~)'

override_dh_installinit:
	dh_installinit --no-start

get-orig-source::
	-uscan --force-download
